#include<bits/stdc++.h>
using namespace std;
string a,b;
map<long long,bool> dali;
long long kude[100001];
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cin>>a;
    long long N;
    cin>>N;
    long long maxa=0,b1=1009,mod=10e9;
    long long siz=0,sizm=10000001;
    for(long long i=0;i<N;i++){
        cin>>b;
        long long has=0;
        for(long long j=0;j<b.size();j++){
            has=has*b1+b[j];
            has%=mod;
        }
        long long siz2=b.size();
        siz=max(siz2,siz);
        sizm=min(sizm,siz2);
        //cout<<has<<endl;
        dali[has]=1;
    }
    for(long long i=0;i<a.size()-(sizm-1);i++){
        long long has=0;
        long long da=-1,kol=0;
        long long c=i;
        while(kude[i]!=0){
            i=kude[i];
            kude[c]=i;
        }
        for(long long j=i;j<a.size();j++){
            c=j;
            while(kude[j]!=0){
                j=kude[j];
                kude[c]=j;
            }
            kol++;
            if(kol>siz){
                break;
            }
            has=has*b1+a[j];
            has%=mod;
            if(dali[has]){
                da=j;
                break;
            }
        }
        if(da!=-1){
            kude[i]=da+1;
            i=0;
        }
    }
    for(long long i=0;i<a.size();i++){
        while(kude[i]!=0){
            i=kude[i];
        }
        cout<<a[i];
    }
    cout<<endl;
    return 0;
}
